#     
#     
#    25  2002
#       2003-10-02
#       2005-10-04 -   
#       2006-12-25      D ( )
#       2007-09-30      :
#                             ( -  )
#                             
#                          ,   
#                            
#                         
#       2007-10-26      P ( )
#       2008-09-27      
#                       :
#                           
#                           (  )
#                           ( )
#       2008-10-31       P ,    I
#       2009-10-06        ""
#
#

#      

#---------------------------------------------------------------------

require 'test-all.pl';

   $fileschecked = 0;
   for $type ('I', 'R', 'D', 'P') {
      $f = "$tournament$type$stage$region.TXT";
      unless (-e $f) {
         error ('w', $msg_filenotexist,$f);
         next;
      }
      unless (open IN, $f) {
         error ($msg_nofile, $f);
         next;
      }
      error ('i',$msg_goodfile,$f);
      $fileschecked++;
      testhead();
      eval "test$type()";
      close IN;
   }
   for $teamcode (sort keys %team) {
      next unless $team{$teamcode}{sum} >= $level{$team{$teamcode}{status}};
      error ($msg_no_report,$teamcode,$team{$teamcode}{status},$team{$teamcode}{sum},'D')
         unless $team{$teamcode}{D};
      error ($msg_no_report,$teamcode,$team{$teamcode}{status},$team{$teamcode}{sum},'P')
         unless $team{$teamcode}{P};
   }
error ('i',$msg_finish,$fileschecked,$errors || "0",$warning||"0");
error ("i","");
db_finish() if $DBTEST;
name_finish() if $DBTEST;

#---------------------------------------------------------------------
#      I -   
#---------------------------------------------------------------------
sub testI
{
   %team=();
   while (<IN>)
   {
      next if newline();
      ($teamcode, $teamgroup, $teamname, $captain, $teamcity) = split /\s*\|\s*/;
      if ($teamcode !~ /^(\w{5})\d{3}$/)
         {error ($msg_I_badteamcode,$teamcode);}
      else
      {
         error ($msg_I_badcitycodeinteam,$teamcode,$1) unless $teamcity || ($1 eq $region);
         $teamcity ||= $city;
         all2ruscaps($teamgroup);
         if (!(($teamstatus,$teamage) = ($teamgroup =~ /^(.)\s*(\d\d)/)))
            {error ($msg_badcategory,$teamcode,$teamgroup);}
         elsif (not exists $ages{$teamage}) {error ($msg_I_badage,$teamcode,$teamage);}
         elsif (not exists $status{$teamstatus}) {error ($msg_I_badstatus,$teamcode,$teamstatus);}
#        elsif ($status{$teamstatus} > $teamage)
#           {error ($msg_I_badagestatus,$teamcode,$teamstatus,$teamage);}
      }
      if (exists $team{$teamcode})
         {error ($msg_doublecode,$teamcode)}
      else {
         %{$team{$teamcode}} = (
            status => $teamstatus,
            age => $teamage,
            name => $teamname,
            cap => $captain,
            city => $teamcity
         );
      }
      error ($msg_I_noteamdata,$teamcode) if !$teamname;
      next unless $DBTEST;
      db_testteam();
   }
}

sub testR
{
   my %tt;
   while (<IN>)
   {
      next if newline();
      my ($tour,$teamcode,@result) = split;
      error ($msg_R_badtour,$tour) unless 1<=$tour && $tour<=$ntours;
      error ($msg_unknownteam,$teamcode) if ! exists $team{$teamcode};
      error ($msg_R_doubletour,$teamcode,$tour) if exists $tt{$teamcode}{$tour};
      $tt{$teamcode}{$tour}=1;
      my $sum = pop @result;
      $team{$teamcode}{sum} += $sum;
      my $res = join "",@result;
      for $q (@qbad) {
         if ( ($tour-1)*$nq < $q  &&  $q <= $tour*$nq  &&
              substr($res, $q-($tour-1)*$nq-1,1) eq '+')
         {
            error ($msg_R_deletedquestion,$teamcode,$q);
         }
      }
      my $nplus = $res =~ tr/+//;
      my $nminus = $res =~ tr/-//;
      error ($msg_R_badsymbol,$f,$teamcode,$tour)
          unless $nplus+$nminus == length $res;
      error ($msg_R_badplusminus,$teamcode) unless $nplus+$nminus == $nq;
      error ($msg_R_badsum,$teamcode) unless $nplus == $sum;
   }
   my ($teamcode,$tour);
   for $teamcode (sort keys %team)
   {
      for $tour (1..$ntours)
      {
         error ($msg_R_notour,$teamcode,$tour)
            unless exists $tt{$teamcode}{$tour}
      }
   }
}

sub testD
{
   my %tt, %qlist;
   while (<IN>)
   {
      next if newline();
      if (/^!\s*(\S+)\s+0*(\d+)$/) {
         error ($msg_strangeline) unless $1 eq $wrd_answer;
         $num = $2;
         error ($msg_badqnumber, $num) unless 1<=$num && $num <= $qmax;
         error ($msg_D_doublelist, $num) if exists $qlist{$num};
         $qlist{$num}=1;
         next;
      }
      unless (/^\S+\s+\S/) {
         error ($msg_strangeline);
         next;
      }
      unless ($num) {
         error ($msg_D_nonumber);
         next;
      }
      (my $teamcode) = split;
      $teamcode = $region.$teamcode if $teamcode=~/^\d\d\d$/;
      error ($msg_unknownteam,$teamcode) unless $team{$teamcode};
      error ($msg_D_doubleans,$teamcode,$num) if $tt{$teamcode}{$num};
      $tt{$teamcode}{$num} = 1;
      $team{$teamcode}{D} = 1;
   }
   for $num (1..$qmax) {
      unless ($qlist{$num}) {
         error ($msg_D_nolist,$f,$num);
         next;
      }
      for $teamcode (sort keys %tt) {
         error ($msg_D_noanswer,$teamcode,$num) unless $tt{$teamcode}{$num};
      }
   }
}

sub testP
{
   my %tt;
   $teamcode = "";
   my $pcount;
   while (<IN>)
   {
      next if newline();
      if (substr($_,0,2) eq substr($region,0,2)) {
         if ($teamcode) {     #    
            error ($msg_P_noplayers, $teamcode) if exists $team{$teamcode} && $pcount==0;
            error ($msg_P_whyplayers, $teamcode) if !(exists $team{$teamcode}) && $pcount>0;
            error ('w',$msg_P_whyold,$teamcode,"$teamstatus$teamage","$max_team_status$max_team_age")
               if $ages{$max_team_age} < $ages{$teamage} ||
                  $status{$max_team_status} < $status{$teamstatus};
         }
         $pcount=0;
         %teamlist = ();
         $max_team_age = 96; $max_team_status = '';
         ($teamcode, $teamgroup, $teamname, $teamcap, $teamcity) = split /\s*\|\s*/;
         db_P_loadteam() if $DBTEST;
         $teamcity ||= $city;
         error ($msg_doublecode,$f,$teamcode) if exists $tt{$teamcode};
         $tt{$teamcode} = 1;
         all2ruscaps($teamgroup);
         if (!(($teamstatus,$teamage) = ($teamgroup =~ /^(.)\s*(\d\d)/)))
            {error ($msg_badcategory,$teamcode,$teamgroup);}
         if (exists $team{$teamcode}) {
            $team{$teamcode}{P} = 1;
            error ($msg_P_badage,$teamcode, $teamage, $team{$teamcode}{age})
               unless $teamage == $team{$teamcode}{age};
            error ($msg_P_badstatus,$teamcode, $teamstatus, $team{$teamcode}{status})
               unless $teamstatus == $team{$teamcode}{status};
            error ($msg_P_badname,$teamcode, $teamname, $team{$teamcode}{name})
               unless $teamname eq $team{$teamcode}{name};
            error ($msg_P_badcap,$teamcode, $teamcap, $team{$teamcode}{cap})
               unless $teamcap eq $team{$teamcode}{cap};
            error ($msg_P_badcity,$teamcode, $teamcity, $team{$teamcode}{city})
               unless $teamcity eq $team{$teamcode}{city};
         }
      }
      else {
         setperson();
         if (exists $teamlist{$name.$surname} &&
            (!$teamlist{$name.$surname} || !$middlename || $teamlist{$name.$surname} eq $middlename))
         {
            error ($msg_P_double,$teamcode,"$name $surname $middlename");
         }
         else {
            $teamlist{$name.$surname} = $middlename;
         }
         # 
         if (!($m && $d && $y)) {
            error($msg_P_badbirth,$birthday);
         }
         else {
            error($msg_P_badyear,$y) unless 1988 <= $y && $y <= 2002;
            error($msg_P_baddate,$birthday)
               unless (1 <= $m && $m <= 12)
                  && ( (1 <= $d && $d <= 28)
                     || (($d==29 || $d==30) && $m!=2)
                     || ($d==31 && ($m==1 || $m==3 || $m==5 || $m==7 || $m==8 || $m==10 || $m==12))
                     || ($d==29 && $m==2 && $y%4 == 0)
                  )
               ;
            error($msg_P_wrongage,$birthday,$teamage) unless $y >= 1900+$teamage;
            error($msg_P_wrongage,$birthday,$teamage) if $teamage == 89 && $y == 1989 && $m < 9;
         }

         # 
         error ($msg_P_badclass,$status) unless $status =~ /^[]$/;
         error ($msg_P_badclassnum,$school)
            unless $school =~ /^[]$/
               ||  $school =~ /^(\s*((1[0-2])|[2-9]))|([]\s*[1-5])$/;
            ;
         $person_status = find_status($school);
         $person_age = find_age($y);
         error($msg_P_wronggroup,$school,$teamstatus) unless
            $status{$person_status} <= $status{$teamstatus};

         ;
         $max_team_age = $person_age if $ages{$person_age} > $ages{$max_team_age};
         $max_team_status = $person_status if $status{$person_status} > $status{$max_team_status};
         # 
         error ($msg_P_toursnumber,$tours) unless length($tours) == $stage;
         error ($msg_P_badtoursym,$tours)
            unless $tours=~tr/-+// == length($tours);
         error ($msg_P_badplayer,$tours) if $tours =~ /^-+$/;
         $pcount++ if substr($tours,-1,1) ne '-';

         next unless $DBTEST;
         name_test();
         db_P_testperson();
      }
   }
   if ($teamcode) {     #    
      error ($msg_P_noplayers, $teamcode) if exists $team{$teamcode} && $pcount==0;
      error ($msg_P_whyplayers, $teamcode) if !(exists $team{$teamcode}) && $pcount>0;
      error ('w',$msg_P_whyold,$teamcode,"$teamstatus$teamage","$max_team_status$max_team_age")
         if $ages{$max_team_age} < $ages{$teamage} ||
            $status{$max_team_status} < $status{$teamstatus};
   }
   db_P_finishteam() if $DBTEST;
}
